#
# Copyright (c) 2012 Canonical
#
# This file is part of Checkbox.
#
# Storm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Storm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
__metaclass__ = type

__all__ = []

import os
import errno
import socket

from checkbox.tests.cases import TestCase
from checkbox.tests.process import ProcessMixin

from checkbox.connector.broker import Broker
from checkbox.connector.sock import Sock


class TestSock(ProcessMixin, TestCase):

    def test_connectEPIPE(self):
        sock = Sock()
        try:
            sock.connect(("127.0.0.1", 0))
        except socket.error, error:
            self.assertEquals(error.errno, errno.EPIPE)
        else:
            self.fail("socket.error not raised")

    def test_connectENOTCONN(self):
        if not self.forkChild():
            broker = Broker("127.0.1.1")
            broker.handleConnectionRequest()
            os._exit(0)

        sock = Sock()
        try:
            sock.connect(("127.0.1.1", 0))
        except socket.error, error:
            self.assertEquals(error.errno, errno.ENOTCONN)
        else:
            self.fail("socket.error not raised")
