#
# Copyright (c) 2012 Canonical
#
# This file is part of Checkbox.
#
# Storm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Storm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
__metaclass__ = type

__all__ = [
    "WaitPid",
    "WaitPidQueue",
    ]

from heapq import (
    heappop,
    heappush,
    )


class WaitPid:

    __slots__ = (
        "child_pid",
        "exit_status",
        )

    def __init__(self, child_pid, exit_status=0):
        self.child_pid = child_pid
        self.exit_status = exit_status

    def __cmp__(self, other):
        return cmp(self.child_pid, other.child_pid)


class WaitPidQueue(list):

    def enqueue(self, item):
        heappush(self, item)

    def dequeue(self):
        return heappop(self)
