#
# Copyright (c) 2012 Canonical
#
# This file is part of Checkbox.
#
# Storm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Storm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
__metaclass__ = type

__all__ = []

import os

from checkbox.tests.cases import TestCase

from checkbox.io.pipe import Pipe

from checkbox.io.tests.stream import StreamMixin


class TestPipe(StreamMixin, TestCase):

    def setUp(self):
        reader_fd, writer_fd = os.pipe()

        self.reader = Pipe()
        self.reader.listen(reader_fd)

        self.writer = Pipe()
        self.writer.connect(writer_fd)

    def getReader(self):
        return self.reader

    def getWriter(self):
        return self.writer
