#
# Copyright (c) 2012 Canonical
#
# This file is part of Checkbox.
#
# Storm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Storm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
__metaclass__ = type

__all__ = []

from checkbox.tests.cases import TestCase

from checkbox.io.selector import (
    Selector,
    SelectorIO,
    )


class TestSelector(TestCase):

    def test_add_remove_fd(self):
        selector = Selector()

        # Add stdout
        selector.add_fd(1, SelectorIO.WRITE)
        selector.execute()
        self.assertTrue(selector.check_fd(1, SelectorIO.WRITE))
        self.assertFalse(selector.check_fd(2, SelectorIO.WRITE))

        # Add stderr
        selector.add_fd(2, SelectorIO.WRITE)
        selector.execute()
        self.assertTrue(selector.check_fd(1, SelectorIO.WRITE))
        self.assertTrue(selector.check_fd(2, SelectorIO.WRITE))

        # Remove stdout
        selector.remove_fd(1, SelectorIO.WRITE)
        selector.execute()
        self.assertFalse(selector.check_fd(1, SelectorIO.WRITE))
        self.assertTrue(selector.check_fd(2, SelectorIO.WRITE))
