#
# Copyright (c) 2012 Canonical
#
# This file is part of Checkbox.
#
# Storm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Storm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
__metaclass__ = type

__all__ = []

import tempfile

from checkbox.tests.cases import TestCase

from checkbox.io.watchdog import (
    WatchdogClient,
    WatchdogServer,
    )


class TestWatchdogClient(TestCase):

    def setUp(self):
        self.path = tempfile.mktemp()

        self.server = WatchdogServer()
        self.server.setPath(self.path)

    def test_set_path(self):
        client = WatchdogClient()
        self.assertTrue(client.setPath(self.path))
        self.assertNotEquals(client.fileno(), -1)


class TestWatchdogServer(TestCase):

    def setUp(self):
        self.path = tempfile.mktemp()

    def test_set_path(self):
        server = WatchdogServer()
        self.assertTrue(server.setPath(self.path))
        self.assertTrue(server.getPath().startswith(self.path))
