#
# Copyright (c) 2012 Canonical
#
# This file is part of Checkbox.
#
# Storm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Storm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
__metaclass__ = type

__all__ = []

from unittest import TestCase

from checkbox.journal.file import (
    FileState,
    FileStateInfo,
    )


class TestFile(TestCase):

    def test_init(self):
        state = FileState()

        info = FileStateInfo()
        state = FileState(info)

    def test_setattr(self):
        state = FileState()
        try:
            state.base_path = ""
        except AttributeError, error:
            self.assertTrue("object has no attribute", str(error))
        else:
            self.fail("AttributeError not raised")

        info = FileStateInfo()
        state = FileState(info)
        state.base_path = ""
        try:
            state.foo = ""
        except AttributeError, error:
            self.assertTrue("object has no attribute", str(error))
        else:
            self.fail("AttributeError not raised")

    def test_getattr(self):
        state = FileState()
        try:
            base_path = state.base_path
        except AttributeError, error:
            self.assertTrue("object has no attribute", str(error))
        else:
            self.fail("AttributeError not raised")

        info = FileStateInfo()
        state = FileState(info)
        base_path = state.base_path
        try:
            foo = state.foo
        except AttributeError, error:
            self.assertTrue("object has no attribute", str(error))
        else:
            self.fail("AttributeError not raised")
