#
# Copyright (c) 2012 Canonical
#
# This file is part of Checkbox.
#
# Storm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Storm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
__metaclass__ = type

__all__ = []

import os
import tempfile

from unittest import TestCase

from checkbox.lib.fifo import fifo_create
from checkbox.lib.file import File


class TestFifo(TestCase):

    def setUp(self):
        self.path = tempfile.mktemp()

    def tearDown(self):
        if os.path.exists(self.path):
            os.unlink(self.path)

    def test_fifo_create(self):
        read_file = File()
        write_file = File()

        self.assertTrue(fifo_create(self.path, read_file, write_file))
        self.assertNotEquals(read_file.fileno(), -1)
        self.assertNotEquals(write_file.fileno(), -1)
