#
# Copyright (c) 2012 Canonical
#
# This file is part of Checkbox.
#
# Storm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Storm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
__metaclass__ = type

__all__ = []

import signal

from unittest import TestCase

from checkbox.lib.sigset import Sigset


class TestSigset(TestCase):

    def test_init(self):
        sigset = Sigset()
        self.assertEquals(len(sigset), 0)

        sigset = Sigset([signal.SIGUSR1])
        self.assertEquals(len(sigset), 1)

    def test_add(self):
        sigset = Sigset()
        self.assertEquals(len(sigset), 0)

        sigset.add(signal.SIGUSR1)
        self.assertEquals(len(sigset), 1)

    def test_fill(self):
        sigset = Sigset()
        self.assertEquals(len(sigset), 0)

        sigset.fill()
        self.assertEquals(len(sigset), signal.NSIG - 1)
