#
# Copyright (c) 2012 Canonical
#
# This file is part of Checkbox.
#
# Storm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Storm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
__metaclass__ = type

__all__ = [
    "EvalLookup",
    "EvalState",
    ]

from checkbox.lib.enum import Enum


EvalLookup = Enum(
    "EVAL_OK",
    "EVAL_UNDEF",
    "EVAL_ERROR",
    )


class EvalState:

    __slots__ = (
        "cache",
        "root",
        "current",
        "flatten_and_inline",
        )

    def __init__(self):
        self.cache = {}
        self.root = None
        self.current = None
        self.flatten_and_inline = False

    def setScope(self, scope):
        self.current = scope
        self.setRootScope()

    def setRootScope(self):
        if self.current == None:
            self.root = None

        else:
            previous = self.current
            current = self.current.parent
            while current:
                if current == self.current:
                    return

                previous = current
                current = current.parent

            self.root = previous
