#
# Copyright (c) 2012 Canonical
#
# This file is part of Checkbox.
#
# Storm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Storm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
__metaclass__ = type

__all__ = [
    "Signal",
    ]

from checkbox.lib.signal import name_to_signal

from checkbox.message.attributes import Attributes


class Signal:

    @classmethod
    def find(cls, record, name):
        if not record:
            return -1

        tree = record.lookup(name)
        if tree:
            value = tree.value
            if not value:
                return -1

            elif isinstance(value, int):
                return value

            elif isinstance(value, basestring):
                return name_to_signal(value)

            else:
                return -1

        return -1

    @classmethod
    def findHold(cls, record):
        return cls.find(record, Attributes.HOLD_SIG)

    @classmethod
    def findKill(cls, record):
        return cls.find(record, Attributes.KILL_SIG)

    @classmethod
    def findRemove(cls, record):
        return cls.find(record, Attributes.REMOVE_SIG)
