#
# Copyright (c) 2012 Canonical
#
# This file is part of Checkbox.
#
# Storm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Storm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
__metaclass__ = type

__all__ = []

from unittest import TestCase

from checkbox.message.literal import LiteralFactor
from checkbox.message.token import (
    TokenType,
    Token,
    )


class TestToken(TestCase):

    def test_type(self):
        token = Token()
        self.assertEquals(token.type, TokenType.TOKEN_ERROR)

    def test_copyFrom(self):
        token1 = Token()
        token1.factor = LiteralFactor.BYTE
        token1.type = TokenType.INTEGER
        token1.value = 1

        token2 = Token()
        token2.copyFrom(token1)
        self.assertEquals(token2.factor, token1.factor)
        self.assertEquals(token2.type, token1.type)
        self.assertEquals(token2.value, token1.value)
