#
# Copyright (c) 2012 Canonical
#
# This file is part of Checkbox.
#
# Storm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Storm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
__metaclass__ = type

__all__ = [
    "get_path",
    ]

import posixpath

from checkbox.lib import param


def get_path():
    path = param.get("PROCESS_PATH")
    if not path:
        # Setup a default for PROCESS_PATH
        directory = param.get("LOCK")
        if not directory:
            directory = param.get("LOG")

        if not directory:
            raise Exception("PROCESS_PATH not defined in configuration")

        path = posixpath.join(directory, "process_pipe")

    return path
