#
# Copyright (c) 2012 Canonical
#
# This file is part of Checkbox.
#
# Storm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Storm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
__metaclass__ = type

__all__ = []

from unittest import TestCase

from checkbox.process.info import Info
from checkbox.process.family import (
    Family,
    FamilyMember,
    )


class TestFamilyMember(TestCase):

    def test_init(self):
        member = FamilyMember()
        self.assertEquals(member.family, None)
        self.assertEquals(member.info, None)

    def test_stillAlive(self):
        info = Info()
        member = FamilyMember()
        self.assertEquals(member.info, None)

        member.stillAlive(info)
        self.assertEquals(member.info, info)

    def test_moveToSubfamily(self):
        member = FamilyMember()

        family1 = Family(None)
        member.moveToSubfamily(family1)
        self.assertTrue(member in family1._member_list)

        family2 = Family(None)
        member.moveToSubfamily(family2)
        self.assertFalse(member in family1._member_list)
        self.assertTrue(member in family2._member_list)


class TestFamily(TestCase):

    def test_init(self):
        Family(None)
