#
# Copyright (c) 2012 Canonical
#
# This file is part of Checkbox.
#
# Storm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Storm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
__metaclass__ = type

__all__ = []

import os

from unittest import TestCase

from checkbox.process.info import Info


class TestInfo(TestCase):

    def test_getInfo(self):
        pid = os.getpid()
        info = Info.getInfo(pid)
        self.assertNotEquals(info, None)

        # Check id
        self.assertEquals(info.pid, pid)
        self.assertEquals(info.ppid, os.getppid())
        self.assertEquals(info.owner, os.getuid())

        # Check size
        self.assertTrue(info.image_size > 0)
        self.assertTrue(info.rss_size > 0)

    def test_getInfos(self):
        infos = list(Info.getInfos())
        self.assertTrue(len(infos) > 0)
