#
# Copyright (c) 2012 Canonical
#
# This file is part of Checkbox.
#
# Storm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Storm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
__metaclass__ = type

__all__ = []

from unittest import TestCase

from checkbox.scripts.tests.config import ConfigMixin

from checkbox.process.manager import create_manager


class TestCreateManager(ConfigMixin, TestCase):

    def test_direct(self):
        manager = create_manager("MASTER")
        self.assertTrue(manager.is_direct)

    def test_indirect(self):
        manager = create_manager("FOO")
        self.assertFalse(manager.is_direct)
