#
# Copyright (c) 2012 Canonical
#
# This file is part of Checkbox.
#
# Storm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Storm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
__metaclass__ = type

__all__ = []

from cStringIO import StringIO

from unittest import TestCase

from checkbox.scripts.mixins.logger import get_logger


class TestGetLogger(TestCase):

    def runLogger(self, log_level):
        log_stream = StringIO()
        logger = get_logger(log_level, log_stream=log_stream)
        logger.error("This is an error")
        logger.warn("This is a warning")
        logger.info("This is info")
        logger.debug("This is debug")
        log_stream.seek(0)
        return log_stream

    def test_error(self):
        log_stream = self.runLogger("ERROR")
        self.assertTrue("This is an error" in log_stream.readline())
        self.assertEquals(log_stream.readline(), "")

    def test_warning(self):
        log_stream = self.runLogger("WARNING")
        self.assertTrue("This is an error" in log_stream.readline())
        self.assertTrue("This is a warning" in log_stream.readline())
        self.assertEquals(log_stream.readline(), "")

    def test_info(self):
        log_stream = self.runLogger("INFO")
        self.assertTrue("This is an error" in log_stream.readline())
        self.assertTrue("This is a warning" in log_stream.readline())
        self.assertTrue("This is info" in log_stream.readline())
        self.assertEquals(log_stream.readline(), "")

    def test_debug(self):
        log_stream = self.runLogger("DEBUG")
        self.assertTrue("This is an error" in log_stream.readline())
        self.assertTrue("This is a warning" in log_stream.readline())
        self.assertTrue("This is info" in log_stream.readline())
        self.assertTrue("This is debug" in log_stream.readline())
        self.assertEquals(log_stream.readline(), "")
