#!/usr/bin/env python
import os
import re

import ez_setup
ez_setup.use_setuptools()

from setuptools import (
    Extension,
    find_packages,
    setup,
    )


def changelog_version(changelog="debian/changelog"):
    version = "dev"
    if os.path.exists(changelog):
        head = open(changelog).readline()
        match = re.compile(".*\((.*)\).*").match(head)
        if match:
            version = match.group(1)

    return version


if os.path.isfile("MANIFEST"):
    os.unlink("MANIFEST")

setup(
    name="checkbox",
    version=changelog_version(),
    description="Checkbox System Testing",
    author="Marc Tardif",
    author_email="marc.tardif@canonical.com",
    license="LGPL",
    ext_modules=[
        Extension(
            "checkbox.lib.sigprocmask", ["checkbox/lib/sigprocmask.c"])],
    packages=find_packages(),
    scripts=[
        "bin/checkbox-broker", "bin/checkbox-client",
        "bin/checkbox-convert", "bin/checkbox-message",
        "bin/checkbox-process-client", "bin/checkbox-process-server",
        ],
    # The following options are specific to setuptools but ignored (with a
    # warning) by distutils.
    include_package_data=True,
    zip_safe=False,
    test_suite="checkbox.tests.find_tests",
    )
